# Copyright (c) 2018-2022  University of Houston Networking Lab

from distutils.core import setup
import setuptools

docs_require = ["sphinx",
                "sphinx_rtd_theme",
                "autodoc"]

setup(name="traffic_metrics",
      version="0.0.0.5",
      description="creates a report with metrics and charts",
      url="http://docs.uh-netlab.org/projects/traffic_metrics",
      author="UH-Netlab, Oluwamayowa Adeleke",
      author_email="oluwamayowa.adeleke@gmail.com",
      packages=setuptools.find_packages(),
      scripts=["bin/traffic_metrics"],
      include_package_data=True,
      zip_safe=False,
      install_requires=[
          "dpkt",
          "numpy",
          "pandas",
          "sklearn",
          "matplotlib",
          "hurst",
          "RegscorePy",
          "pywavelets",
          "scipy",
          "dash==0.40.0",
          "dash_core_components==0.45.0",
          "dash_bootstrap_components==0.4.0",
          "dash_html_components==0.15.0",
          "plotly",
          "flask",
          "statistics",
          "jsbeautifier"
          ],
      extras_require = { "docs" : docs_require },
      classifiers = [
        "Development Status :: 3 - Alpha",
        "Environment :: Console",
        "Programming Language :: Python :: 3",
        "License :: OSI Approved :: Mozilla Public License 2.0 (MPL 2.0)",
        ],
      python_requires=">=3.6",
      )
