time_resolution = 0.1 #secs

#general metrics
packet_rate = 'packet_rate'
inter_packet_time = 'inter_packet_time'
throughput = "throughput"
packet_size = "packet_size"
#layer2 metrics
l2_payload_throughput = 'l2_payload_throughput'
l2_payload_size = 'l2_payload_size'
#layer3 metrics
l3_payload_throughput = 'l3_payload_throughput'
l3_payload_size = 'l3_payload_size'
#layer4 metrics
l4_payload_throughput = 'l4_payload_throughput'
l4_payload_size = 'l4_payload_size'
l4_tcp_retransmitted_rate = 'l4_tcp_retransmitted_rate' 
l4_outoforder_rate = 'l4_outoforder_rate'
l4_window_size = 'l4_window_size'
l4_unacked_inflight_data = 'l4_unacked_inflight_data'
#app level metrics
app_pdu_rate = 'app_pdu_rate'
app_pdu_throughput = 'app_pdu_throughput'
app_inter_pdu_time = 'app_inter_pdu_time'
app_srv_resp_time = 'app_srv_resp_time'
app_pdu_size = 'app_pdu_size'
app_pdu_throughput_no_zeros = 'app_pdu_throughput_no_zeros'
app_pdu_rate_no_zeros = 'app_pdu_rate_no_zeros'
#new
app_request_rate_no_zeros = 'app_request_rate_no_zeros'
app_response_rate_no_zeros = 'app_response_rate_no_zeros'
app_request_throughput_no_zeros = 'app_request_throughput_no_zeros'
app_response_throughput_no_zeros = 'app_response_throughput_no_zeros'
app_inter_request_time = 'app_inter_request_time'
app_inter_response_time = 'app_inter_response_time'
#conn level metrics
conn_inter_arrival_time = 'conn_inter_arrival_time'
conn_arrival_rate_no_zeros = 'conn_arrival_rate_no_zeros'
#=================================================================

#units
packets_per_second='packets_per_second'
bits_per_second='bits_per_second'
Bytes='Bytes'
seconds='seconds'
pdus_per_second='pdus_per_second'
connections_per_sec='connections_per_sec'


conn_pkts_reqd_metrics = [l4_unacked_inflight_data]

pkt_graph_metrics = [packet_rate,
                    inter_packet_time,
                    throughput,
                    packet_size,

                    l2_payload_throughput,
                    l2_payload_size,
                    
                    l3_payload_throughput,
                    l3_payload_size,
                    
                    l4_payload_throughput,
                    l4_payload_size,
                    l4_tcp_retransmitted_rate,
                    l4_outoforder_rate,
                    l4_window_size,
                    #l4_unacked_inflight_data
                    ]

pdu_graph_metrics = [ 
                     app_pdu_size,
                     app_inter_pdu_time, 
                     app_srv_resp_time,
                     app_pdu_rate, 
                     app_pdu_rate_no_zeros,
                     app_pdu_throughput,
                     app_pdu_throughput_no_zeros,
                     app_request_rate_no_zeros,
                     app_response_rate_no_zeros,
                     app_request_throughput_no_zeros,
                     app_response_throughput_no_zeros,
                     app_inter_request_time,
                     app_inter_response_time,
                    ]

conn_graph_metrics = [
                     conn_inter_arrival_time,
                     conn_arrival_rate_no_zeros
                     ]

per_pkt_metrics = [inter_packet_time,
                   packet_size,
                   l2_payload_size,
                   l3_payload_size,
                   l4_payload_size,
                   l4_window_size,
                   #l4_unacked_inflight_data,
                   app_pdu_size,
                   app_inter_pdu_time,
                   app_srv_resp_time,
                   app_inter_request_time,
                   app_inter_response_time,
                   conn_inter_arrival_time, #bcos its per conn
                   ]


metric_units = {
                    packet_rate: packets_per_second,
                    inter_packet_time: seconds,
                    throughput: bits_per_second,
                    packet_size: Bytes,

                    l2_payload_throughput: bits_per_second,
                    l2_payload_size: Bytes,
                    
                    l3_payload_throughput: bits_per_second,
                    l3_payload_size: Bytes,
                    
                    l4_payload_throughput: bits_per_second,
                    l4_payload_size: Bytes,
                    l4_tcp_retransmitted_rate: packets_per_second, 
                    l4_outoforder_rate: packets_per_second,
                    l4_window_size: Bytes,
                    l4_unacked_inflight_data: bits_per_second,

                    app_pdu_size: Bytes,
                    app_inter_pdu_time: seconds, 
                    app_srv_resp_time: seconds,
                    app_pdu_rate: pdus_per_second, 
                    app_pdu_rate_no_zeros: pdus_per_second,
                    app_pdu_throughput: bits_per_second,
                    app_pdu_throughput_no_zeros: bits_per_second,

                    app_request_rate_no_zeros: pdus_per_second,
                    app_response_rate_no_zeros: pdus_per_second,
                    app_request_throughput_no_zeros: bits_per_second,
                    app_response_throughput_no_zeros: bits_per_second,
                    app_inter_request_time: seconds,
                    app_inter_response_time: seconds,
                    
                    conn_inter_arrival_time: seconds,
                    conn_arrival_rate_no_zeros: connections_per_sec
                    
               }
