import sys
import json
import csv


def fmt(val):
    if isinstance(val,float):
        return float('%.4f' % (val))
    return val

class Report2TableUsess ():
    def __init__(self):
        pass

    def convert(self, reportjsonfile, outfile):
        jo = json.load(open(reportjsonfile))
        with open(outfile, 'wb') as csvfile:
            cwriter = csv.writer(csvfile, quoting=csv.QUOTE_MINIMAL)
            cwriter.writerow(['Table'])
            cwriter.writerow([])
            cwriter.writerow(['Single Valued Metrics'])

            apps = list(jo.keys())
            var_metrics = []
            stats = []
            summary_metrics = []
            traces = []    

            for key, val in jo.items():
                if 'traffic' in key or key.startswith('Packets-') or key.startswith('Pdus-'):
                    summary_metrics = list(val.keys())

            if len(apps) > 0:
                app0 = apps[0]
                var_metrics = list(jo[app0].keys())
                #print('var_metrics', var_metrics)
                if len(var_metrics) > 0:
                    metric0 = var_metrics[0]
                    traces = jo[app0][metric0]
                    #print('traces', traces)
                    traces = [i for i in traces if i != 'comparison']
                    if len(traces) > 0:
                        traces0 = traces[0]
                        stats = [i for i,v in  jo[app0][metric0][traces0].items() if len(v)>0]
                        #print('stats',stats)

            cwriter.writerow([''] + summary_metrics)

            print()
            print ('apps', apps)
            print()
            print ('var_metrics', var_metrics)
            print()
            print ('traces', traces)
            print()
            print('stats',stats)
            print()

            for tr in traces:
                vals = [tr]
                print(tr)
                for metric_v in summary_metrics:
                    vals.append(jo[tr][metric_v])
                cwriter.writerow(vals)

            cwriter.writerow(['Time Varying Metrics'])
            for app in apps:
                if app == '514.0udp' or app == '80.0tcp':
                    continue
                cwriter.writerow([])
                cwriter.writerow([app])

                
                # print ('jo[str(apps[0])]', jo[str(apps [0])])
                # print()
                # print ('jo[str(apps[0])][var_metrics[0]]', jo[str(apps[0])][var_metrics[0]])


                ki = None
                for i in jo[apps[0]][var_metrics[0]].keys():
                    if i != 'comparison':
                        ki = i
                        break
                print(ki)
                if ki == None:
                    break

                #ki = jo[apps[0]][var_metrics[0]].keys()[0]
                ind_stats = list(jo[apps[0]][var_metrics[0]][ki].keys())
                ind_st = [''] * (len(ind_stats) * len(traces))
                ind_st[0::len(traces)] = ind_stats
                print ('ind_stats', ind_stats)
                print ('ind_st', ind_st)



                compare_rels = list(jo[apps[0]][var_metrics[0]]["comparison"].keys())
                if len(compare_rels) > 0 :
                    compare_stats = list(jo[apps[0]][var_metrics[0]]["comparison"][compare_rels[0]].keys())
                    compare_st = [''] * (len(compare_stats) * len(compare_rels))
                    compare_st[0::len(compare_rels)] = compare_stats
                else:
                    compare_stats = []
                    compare_st = []
                print('compare_stats', compare_stats)
                print('compare_st', compare_st)

                cwriter.writerow([''] + ind_st + compare_st)
                cwriter.writerow([''] + traces * len(ind_stats) + compare_rels * len(compare_stats))
                
                for metric_v in var_metrics:
                    row = [metric_v]
                    for st in ind_stats:
                        for tr in traces:
                            if tr in jo[app][metric_v] and st in jo[app][metric_v][tr]:
                                l = float(len(jo[app][metric_v][tr][st]))
                                if l>0:
                                    row.append(fmt(sum(jo[app][metric_v][tr][st])/l))
                                else:
                                    row.append('')
                            else:
                                row.append('')
                    print (list(app, metric_v, jo[app][metric_v]['comparison'].keys()))
                    for cst in jo[app][metric_v]['comparison'].keys():
                        for cr in jo[app][metric_v]['comparison'][cst].keys():
                            print('  ', cst, cr, list(jo[app][metric_v]['comparison'][cst].keys()))
                            if metric_v in jo[app] and cr in jo[app][metric_v]['comparison'][cst]:
                                print ('  yes')
                                l = float(len(jo[app][metric_v]['comparison'][cst][cr]))
                                if l > 0:
                                    row.append(fmt(sum(jo[app][metric_v]['comparison'][cst][cr])/l))
                                else:
                                    row.append('')
                    cwriter.writerow(row)
            cwriter.writerow([])
if __name__ == '__main__':
    Report2TableUsess().convert(sys.argv[1], sys.argv[2])
